diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy-operating-channel.cc ns-3.34/src/wifi/model/wifi-phy-operating-channel.cc
--- ns-3.33/src/wifi/model/wifi-phy-operating-channel.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy-operating-channel.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,196 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Stefano Avallone <stavallo@unina.it>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "ns3/log.h"
+#include "wifi-phy.h"
+#include <algorithm>
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("WifiPhyOperatingChannel");
+
+WifiPhyOperatingChannel::WifiPhyOperatingChannel ()
+  : m_channelIt (WifiPhy::m_frequencyChannels.end ()),
+    m_primary20Index (0)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+WifiPhyOperatingChannel::~WifiPhyOperatingChannel ()
+{
+  NS_LOG_FUNCTION_NOARGS ();
+}
+
+bool
+WifiPhyOperatingChannel::IsSet (void) const
+{
+  return m_channelIt != WifiPhy::m_frequencyChannels.end ();
+}
+
+void
+WifiPhyOperatingChannel::Set (uint8_t number, uint16_t frequency, uint16_t width,
+                              WifiPhyStandard standard, WifiPhyBand band)
+{
+  NS_LOG_FUNCTION (this << +number << frequency << width << standard << band);
+
+  auto channelIt = FindFirst (number, frequency, width, standard, band, WifiPhy::m_frequencyChannels.begin ());
+
+  if (channelIt != WifiPhy::m_frequencyChannels.end ()
+      && FindFirst (number, frequency, width, standard, band, std::next (channelIt))
+         == WifiPhy::m_frequencyChannels.end ())
+    {
+      // a unique channel matches the specified criteria
+      m_channelIt = channelIt;
+      m_primary20Index = 0;
+      return;
+    }
+
+  // if a unique channel was not found, throw an exception (mainly for unit testing this code)
+  throw std::runtime_error ("WifiPhyOperatingChannel: No unique channel found given the specified criteria");
+}
+
+void
+WifiPhyOperatingChannel::SetDefault (uint16_t width, WifiPhyStandard standard, WifiPhyBand band)
+{
+  NS_LOG_FUNCTION (this << width << standard << band);
+
+  auto channelIt = FindFirst (0, 0, width, standard, band, WifiPhy::m_frequencyChannels.begin ());
+
+  if (channelIt != WifiPhy::m_frequencyChannels.end ())
+    {
+      // a channel matches the specified criteria
+      m_channelIt = channelIt;
+      m_primary20Index = 0;
+      return;
+    }
+
+  // if a default channel was not found, throw an exception (mainly for unit testing this code)
+  throw std::runtime_error ("WifiPhyOperatingChannel: No default channel found of the given width and for the given PHY standard and band");
+}
+
+WifiPhyOperatingChannel::ConstIterator
+WifiPhyOperatingChannel::FindFirst (uint8_t number, uint16_t frequency, uint16_t width,
+                                    WifiPhyStandard standard, WifiPhyBand band,
+                                    ConstIterator start) const
+{
+  NS_LOG_FUNCTION (this << +number << frequency << width << standard << band);
+
+  // lambda used to match channels against the specified criteria
+  auto predicate = [&](const FrequencyChannelInfo& channel)
+    {
+      if (number != 0 && std::get<0> (channel) != number)
+        {
+          return false;
+        }
+      if (frequency != 0 && std::get<1> (channel) != frequency)
+        {
+          return false;
+        }
+      if (width > GetMaximumChannelWidth (standard))
+        {
+          return false;
+        }
+      if (width != 0 && std::get<2> (channel) != width)
+        {
+          return false;
+        }
+      if (std::get<3> (channel) != GetFrequencyChannelType (standard))
+        {
+          return false;
+        }
+      if (std::get<4> (channel) != band)
+        {
+          return false;
+        }
+      return true;
+    };
+
+  return std::find_if (start, WifiPhy::m_frequencyChannels.end (), predicate);
+}
+
+uint8_t
+WifiPhyOperatingChannel::GetNumber (void) const
+{
+  NS_ASSERT (IsSet ());
+  return std::get<0> (*m_channelIt);
+}
+
+uint16_t
+WifiPhyOperatingChannel::GetFrequency (void) const
+{
+  NS_ASSERT (IsSet ());
+  return std::get<1> (*m_channelIt);
+}
+
+uint16_t
+WifiPhyOperatingChannel::GetWidth (void) const
+{
+  NS_ASSERT (IsSet ());
+  return std::get<2> (*m_channelIt);
+}
+
+uint8_t
+WifiPhyOperatingChannel::GetPrimaryChannelIndex (uint16_t primaryChannelWidth) const
+{
+  NS_LOG_FUNCTION (this << primaryChannelWidth);
+
+  if (primaryChannelWidth % 20 != 0)
+    {
+      NS_LOG_DEBUG ("The operating channel width is not a multiple of 20 MHz; return 0");
+      return 0;
+    }
+
+  NS_ASSERT (primaryChannelWidth <= GetWidth ());
+
+  // the index of primary40 is half the index of primary20; the index of
+  // primary80 is half the index of primary40, ...
+  uint16_t width = 20;
+  uint8_t index = m_primary20Index;
+
+  while (width < primaryChannelWidth)
+    {
+      index /= 2;
+      width *= 2;
+    }
+  NS_LOG_LOGIC ("Return " << +index);
+  return index;
+}
+
+void
+WifiPhyOperatingChannel::SetPrimary20Index (uint8_t index)
+{
+  NS_LOG_FUNCTION (this << +index);
+
+  NS_ABORT_MSG_IF (index > 0 && index >= GetWidth () / 20, "Primary20 index out of range");
+  m_primary20Index = index;
+}
+
+uint16_t
+WifiPhyOperatingChannel::GetPrimaryChannelCenterFrequency (uint16_t primaryChannelWidth) const
+{
+  uint16_t freq = GetFrequency () - GetWidth () / 2.
+                  + (GetPrimaryChannelIndex (primaryChannelWidth) + 0.5) * primaryChannelWidth;
+
+  NS_LOG_FUNCTION (this << primaryChannelWidth << freq);
+  return freq;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy-operating-channel.h ns-3.34/src/wifi/model/wifi-phy-operating-channel.h
--- ns-3.33/src/wifi/model/wifi-phy-operating-channel.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy-operating-channel.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,155 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Stefano Avallone <stavallo@unina.it>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef WIFI_PHY_OPERATING_CHANNEL_H
+#define WIFI_PHY_OPERATING_CHANNEL_H
+
+#include "wifi-phy-band.h"
+#include "wifi-standards.h"
+#include <tuple>
+#include <set>
+
+namespace ns3 {
+
+/**
+  * A tuple (number, frequency, width, type, band) identifying a frequency channel
+  */
+typedef std::tuple<uint8_t, uint16_t, uint16_t, FrequencyChannelType, WifiPhyBand> FrequencyChannelInfo;
+
+
+/**
+ * \ingroup wifi
+ *
+ * Class that keeps track of all information about the current PHY operating channel.
+ */
+class WifiPhyOperatingChannel
+{
+public:
+  /**
+   * Create an uninitialized PHY operating channel.
+   */
+  WifiPhyOperatingChannel ();
+
+  virtual ~WifiPhyOperatingChannel ();
+
+  /**
+   * Return true if a valid channel has been set, false otherwise.
+   *
+   * \return true if a valid channel has been set, false otherwise
+   */
+  bool IsSet (void) const;
+  /**
+   * Set the channel according to the specified parameters if a unique
+   * frequency channel matches the specified criteria, or abort the
+   * simulation otherwise.
+   * If the channel width is a multiple of 20 MHz, the primary 20 MHz channel
+   * is set to the 20 MHz subchannel with the lowest center frequency.
+   *
+   * \param number the channel number (use 0 to leave it unspecified)
+   * \param frequency the channel center frequency in MHz (use 0 to leave it unspecified)
+   * \param width the channel width in MHz (use 0 to leave it unspecified)
+   * \param standard the PHY standard
+   * \param band the PHY band
+   */
+  void Set (uint8_t number, uint16_t frequency, uint16_t width,
+            WifiPhyStandard standard, WifiPhyBand band);
+  /**
+   * Set the default channel of the given width and for the given PHY standard and band.
+   * If the channel width is a multiple of 20 MHz, the primary 20 MHz channel
+   * is set to the 20 MHz subchannel with the lowest center frequency.
+   *
+   * \param width the channel width in MHz
+   * \param standard the PHY standard
+   * \param band the PHY band
+   */
+  void SetDefault (uint16_t width, WifiPhyStandard standard, WifiPhyBand band);
+
+  /**
+   * Return the channel number identifying the whole operating channel.
+   *
+   * \return the channel number identifying the whole operating channel
+   */
+  uint8_t GetNumber (void) const;
+  /**
+   * Return the center frequency of the operating channel (in MHz).
+   *
+   * \return the center frequency of the operating channel (in MHz)
+   */
+  uint16_t GetFrequency (void) const;
+  /**
+   * Return the width of the whole operating channel (in MHz).
+   *
+   * \return the width of the whole operating channel (in MHz)
+   */
+  uint16_t GetWidth (void) const;
+
+  /**
+   * If the operating channel width is a multiple of 20 MHz, return the index of the
+   * primary channel of the given width within the operating channel (0 indicates
+   * the 20 MHz subchannel with the lowest center frequency). Otherwise, return 0.
+   *
+   * \param primaryChannelWidth the width of the primary channel in MHz
+   * \return the index of the requested primary channel within the operating channel
+   */
+  uint8_t GetPrimaryChannelIndex (uint16_t primaryChannelWidth) const;
+  /**
+   * Set the index of the primary 20 MHz channel (0 indicates the 20 MHz subchannel
+   * with the lowest center frequency).
+   *
+   * \param index the index of the primary 20 MHz channel
+   */
+  void SetPrimary20Index (uint8_t index);
+  /**
+   * Get the center frequency of the primary channel of the given width.
+   *
+   * \param primaryChannelWidth the width of the primary channel in MHz
+   * \return the center frequency of the primary channel of the given width
+   */
+  uint16_t GetPrimaryChannelCenterFrequency (uint16_t primaryChannelWidth) const;
+
+private:
+  /// Typedef for a const iterator pointing to a channel in the set of available channels
+  typedef std::set<FrequencyChannelInfo>::const_iterator ConstIterator;
+
+  /**
+   * Find the first channel matching the specified parameters.
+   *
+   * \param number the channel number (use 0 to leave it unspecified)
+   * \param frequency the channel center frequency in MHz (use 0 to leave it unspecified)
+   * \param width the channel width in MHz (use 0 to leave it unspecified)
+   * \param standard the PHY standard
+   * \param band the PHY band
+   * \param start an iterator pointing to the channel to start the search with
+   * \return an iterator pointing to the found channel, if any, or to past-the-end
+   *         of the set of available channels
+   */
+  ConstIterator FindFirst (uint8_t number, uint16_t frequency, uint16_t width,
+                           WifiPhyStandard standard, WifiPhyBand band,
+                           ConstIterator start) const;
+
+  ConstIterator m_channelIt;   //!< const iterator pointing to the configured frequency channel
+  uint8_t m_primary20Index;    /**< index of the primary20 channel (0 indicates the 20 MHz
+                                    subchannel with the lowest center frequency) */
+};
+
+} //namespace ns3
+
+#endif /* WIFI_PHY_OPERATING_CHANNEL_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy-state-helper.cc ns-3.34/src/wifi/model/wifi-phy-state-helper.cc
--- ns-3.33/src/wifi/model/wifi-phy-state-helper.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy-state-helper.cc	2021-07-14 10:31:07.000000000 -0700
@@ -26,6 +26,7 @@
 #include "wifi-tx-vector.h"
 #include "wifi-phy-listener.h"
 #include "wifi-psdu.h"
+#include "wifi-phy.h"
 
 namespace ns3 {
 
@@ -464,29 +465,30 @@
 }
 
 void
-WifiPhyStateHelper::ContinueRxNextMpdu (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector)
+WifiPhyStateHelper::ContinueRxNextMpdu (Ptr<WifiPsdu> psdu, RxSignalInfo rxSignalInfo, WifiTxVector txVector)
 {
-  NS_LOG_FUNCTION (this << *psdu << snr << txVector);
+  NS_LOG_FUNCTION (this << *psdu << rxSignalInfo << txVector);
   std::vector<bool> statusPerMpdu;
   if (!m_rxOkCallback.IsNull ())
     {
-      m_rxOkCallback (psdu, snr, txVector, statusPerMpdu);
+      m_rxOkCallback (psdu, rxSignalInfo, txVector, statusPerMpdu);
     }
 }
 
 void
-WifiPhyStateHelper::SwitchFromRxEndOk (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, uint16_t staId, std::vector<bool> statusPerMpdu)
+WifiPhyStateHelper::SwitchFromRxEndOk (Ptr<WifiPsdu> psdu, RxSignalInfo rxSignalInfo, WifiTxVector txVector, uint16_t staId, std::vector<bool> statusPerMpdu)
 {
-  NS_LOG_FUNCTION (this << *psdu << snr << txVector << statusPerMpdu.size () <<
+  NS_LOG_FUNCTION (this << *psdu << rxSignalInfo << txVector << staId << statusPerMpdu.size () <<
                    std::all_of(statusPerMpdu.begin(), statusPerMpdu.end(), [](bool v) { return v; })); //returns true if all true
   NS_ASSERT (statusPerMpdu.size () != 0);
-  NS_ASSERT (m_endRx == Simulator::Now ());
-  m_rxOkTrace (psdu->GetPacket (), snr, txVector.GetMode (staId), txVector.GetPreambleType ());
+  NS_ASSERT (Abs (m_endRx - Simulator::Now ()) < MicroSeconds (1)); //1us corresponds to the maximum propagation delay (delay spread)
+  //TODO: a better fix would be to call the function once all HE TB PPDUs are received
+  m_rxOkTrace (psdu->GetPacket (), rxSignalInfo.snr, txVector.GetMode (staId), txVector.GetPreambleType ());
   NotifyRxEndOk ();
   DoSwitchFromRx ();
   if (!m_rxOkCallback.IsNull ())
     {
-      m_rxOkCallback (psdu, snr, txVector, statusPerMpdu);
+      m_rxOkCallback (psdu, rxSignalInfo, txVector, statusPerMpdu);
     }
 }
 
@@ -494,7 +496,8 @@
 WifiPhyStateHelper::SwitchFromRxEndError (Ptr<WifiPsdu> psdu, double snr)
 {
   NS_LOG_FUNCTION (this << *psdu << snr);
-  NS_ASSERT (m_endRx == Simulator::Now ());
+  NS_ASSERT (Abs (m_endRx - Simulator::Now ()) < MicroSeconds (1)); //1us corresponds to the maximum propagation delay (delay spread)
+  //TODO: a better fix would be to call the function once all HE TB PPDUs are received
   m_rxErrorTrace (psdu->GetPacket (), snr);
   NotifyRxEndError ();
   DoSwitchFromRx ();
@@ -591,7 +594,7 @@
 WifiPhyStateHelper::SwitchFromRxAbort (void)
 {
   NS_LOG_FUNCTION (this);
-  NS_ASSERT (IsStateRx ());
+  NS_ASSERT (IsStateCcaBusy ()); //abort is called (with OBSS_PD_CCA_RESET reason) before RX is set by payload start
   NotifyRxEndOk ();
   DoSwitchFromRx ();
   m_endCcaBusy = Simulator::Now ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy-state-helper.h ns-3.34/src/wifi/model/wifi-phy-state-helper.h
--- ns-3.33/src/wifi/model/wifi-phy-state-helper.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy-state-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -26,7 +26,7 @@
 #include "ns3/traced-callback.h"
 #include "ns3/nstime.h"
 #include "wifi-phy-state.h"
-#include "wifi-preamble.h"
+#include "wifi-phy-common.h"
 #include "wifi-ppdu.h"
 
 namespace ns3 {
@@ -36,6 +36,7 @@
 class WifiMode;
 class Packet;
 class WifiPsdu;
+struct RxSignalInfo;
 
 /**
  * Callback if PSDU successfully received (i.e. if aggregate,
@@ -43,11 +44,12 @@
  * considering that the per-MPDU reception status is also provided).
  *
  * arg1: PSDU received successfully
- * arg2: SNR of PSDU in linear scale
+ * arg2: info on the received signal (\see RxSignalInfo)
  * arg3: TXVECTOR of PSDU
  * arg4: vector of per-MPDU status of reception.
  */
-typedef Callback<void, Ptr<WifiPsdu>, double, WifiTxVector, std::vector<bool>> RxOkCallback;
+typedef Callback<void, Ptr<WifiPsdu>, RxSignalInfo,
+                       WifiTxVector, std::vector<bool>> RxOkCallback;
 /**
  * Callback if PSDU unsuccessfully received
  *
@@ -187,20 +189,21 @@
    * Continue RX after the reception of an MPDU in an A-MPDU was successful.
    *
    * \param psdu the successfully received PSDU
-   * \param snr the SNR of the received PSDU in linear scale
+   * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
    * \param txVector TXVECTOR of the PSDU
    */
-  void ContinueRxNextMpdu (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector);
+  void ContinueRxNextMpdu (Ptr<WifiPsdu> psdu, RxSignalInfo rxSignalInfo, WifiTxVector txVector);
   /**
    * Switch from RX after the reception was successful.
    *
    * \param psdu the successfully received PSDU
-   * \param snr the SNR of the received PSDU in linear scale
+   * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
    * \param txVector TXVECTOR of the PSDU
    * \param staId the station ID of the PSDU (only used for MU)
    * \param statusPerMpdu reception status per MPDU
    */
-  void SwitchFromRxEndOk (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, uint16_t staId, std::vector<bool> statusPerMpdu);
+  void SwitchFromRxEndOk (Ptr<WifiPsdu> psdu, RxSignalInfo rxSignalInfo, WifiTxVector txVector,
+                          uint16_t staId, std::vector<bool> statusPerMpdu);
   /**
    * Switch from RX after the reception failed.
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy-tag.h ns-3.34/src/wifi/model/wifi-phy-tag.h
--- ns-3.33/src/wifi/model/wifi-phy-tag.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy-tag.h	2021-07-14 10:31:07.000000000 -0700
@@ -22,7 +22,7 @@
 #define WIFI_PHY_TAG_H
 
 #include "ns3/tag.h"
-#include "wifi-preamble.h"
+#include "wifi-phy-common.h"
 #include "wifi-mode.h"
 
 namespace ns3 {
